function YYsim = dsgepredmult_pt_svms01(sol, Xhatlast, R, V, sigtlast, horizon, ntraj, order_app)
% for the point prediction (no simulation required)
% procedure to compute multiple predictions
% Remark
%  - I used chol insead of cholpsd

% recover solution
DD = sol.DD;
ZZ = sol.ZZ;
HH = sol.HH;
CC1 = sol.CC1;
CC2 = sol.CC2;
TT = sol.TT;
RR = sol.RR;
QQ = sol.QQ;
RRsqrtQQ = RR*chol(QQ)'; %QQ is eye

strans = sol.strans;

% size of matrices
ne        = size(RR,2);
[ny, nx]  = size(ZZ);
nm        = size(HH,1); %# of measured variable
nvar      = nm;

% simulate path
Mt    = sol.mtlast;

ht    = log(sigtlast'); % vol states
Xt    = Xhatlast'; %states
YYsim = zeros(ntraj, nvar*horizon); %prediction

for trajind = 1:1:ntraj
    
    YYfcst = zeros(horizon, nvar);
    Xtfcst = Xt;
    Htfcst = ht;
    Mtfcst = Mt;
    
    for t = 1:1:horizon
        
        % SV
        %Htfcst = diag(R)*Htfcst + diag(sqrt(V))*randn(ne,1);
        
        % average CC (only works for the first step ahead pred)
        probs = strans*Mtfcst';
        draws = rand < probs(1);
        Mtfcst = [draws, (1-draws)];
        CC = probs(1)*CC1 + probs(2)*CC2;
        
        % States
        %Xtfcst = CC + TT*Xtfcst + RRsqrtQQ*diag(exp(Htfcst))*randn(ne,1); 
        Xtfcst = CC + TT*Xtfcst; 
        
        % Measurement
        %YYfcst(t,:) = (DD + ZZ*Xtfcst + HH*randn(nm,1))';
        YYfcst(t,:) = (DD + ZZ*Xtfcst )';
        
    end
    
    YYsim(trajind,:) = reshape(YYfcst,[],1)';
    
end
