function YYsim = dsgepredmult_sv(sol, Xhatlast, R, V, sigtlast, horizon, ntraj, order_app)
% procedure to compute multiple predictions
% Remark
%  - I used chol insead of cholpsd

% recover solution
DD = sol.DD;
ZZ = sol.ZZ;
HH = sol.HH;
CC = sol.CC;
TT = sol.TT;
RR = sol.RR;
QQ = sol.QQ;
RRsqrtQQ = RR*chol(QQ)'; %QQ is eye

% size of matrices
ne        = size(RR,2);
[ny, nx]  = size(ZZ);
nm        = size(HH,1); %# of measured variable
nvar      = nm;

% simulate path
ht    = log(sigtlast'); % vol states
Xt    = Xhatlast'; %states
YYsim = zeros(ntraj, nvar*horizon); %prediction

for trajind = 1:1:ntraj
    
    YYfcst = zeros(horizon, nvar);
    Xtfcst = Xt;
    Htfcst = ht;
    
    for t = 1:1:horizon
        
        % SV
        Htfcst = diag(R)*Htfcst + diag(sqrt(V))*randn(ne,1);
        
        % States
        Xtfcst = CC + TT*Xtfcst + RRsqrtQQ*diag(exp(Htfcst))*randn(ne,1); 
        
        % Measurement
        YYfcst(t,:) = (DD + ZZ*Xtfcst + HH*randn(nm,1))';
        
    end
    
    YYsim(trajind,:) = reshape(YYfcst,[],1)';
    
end
