function [roll_m, roll_s, roll_r] = roll_mom(YYR, window)
% rolling moments
% window = 50;

[nobs, nv] = size(YYR);

roll_m = zeros(nobs-window+1,nv);
roll_s = zeros(nobs-window+1,nv);
roll_r = zeros(nobs-window+1,nv^2);
for i=1:1:nobs-window+1
    
    roll_m(i,:) = mean(YYR(i:window+i-1,:));
    roll_s(i,:) = std(YYR(i:window+i-1,:));
    roll_r(i,:) = reshape(corr(YYR(i:window+i-1,:)),[],1);
end


figure
plot(roll_m)
legend('y', 'p', 'r');
title('rolling mean');

figure
plot(roll_s)
legend('y', 'p', 'r');
title('rolling std');

figure
plot(roll_r(:,[2 3 6]))
legend('y vs p', 'y vs r', 'p vs r');
title('rolling corr');