function cset = credible_set(rst, crd)
% ----------------------------------------------------------
% credible set for unimodal density
% ----------------------------------------------------------
% rst : result vector
% crd : credible level
n      = size(rst,1);
s_rst  = sort(rst);
lgth   = round(crd*n);

temp   = zeros(n-lgth+1,1);
for i=1:1:n-lgth+1
    temp(i,1) = s_rst(i+lgth-1,1) - s_rst(i,1);
end

[mtemp, indx] = min(temp);
cset = [s_rst(indx,1) s_rst(indx+lgth-1)];