function show_pr(prior, mh_para, trlb, trub, pnames)


% mh_draw?
if nargin <2
    yes_mh = 0;
else
    yes_mh = 1;
end

if isempty(mh_para)
yes_mh = 0;
end

% lower and upper bounds
if nargin <3
    trspec = prtr();
    trlb = trspec(:,2);
    trub = trspec(:,3);
    
    trlb(13:15,1) = 0; trub(13:15,1) = 0.01;
    
    trlb(17,1) = 0; trub(17,1) = 1;
    trlb(19,1) = 0; trub(19,1) = 1;
    trlb(20,1) = 0; trub(20,1) = 0.01;
    
    trlb(21,1) = -0.1; trub(21,1) = 0.1;
end

if nargin <5
    % parameter names
    [trash, pnames] = psel('');
end

% prior
pshape   = prior(:,1);
pmean    = prior(:,2);
pstdd    = prior(:,3);
pmask    = prior(:,4);
pfix     = prior(:,5);
pmaskinv = 1- pmask;
pshape   = pshape.*pmaskinv;

% some information
npara = size(prior,1);
ngrid = 2000; % number of grid to draw density

% for fixed parameter
big_cell = cell(npara,2);
big_cell2 = cell(npara,2);

for para_ind = 1:1:npara
    
    % grid
    temp_lb = trlb(para_ind, 1); % lower bound
    temp_ub = trub(para_ind, 1); % upper bound
    para_grid = linspace(temp_lb, temp_ub,ngrid)';
    
    % prior
    temp_lnprior = zeros(ngrid,1);
    for i=1:1:ngrid
        temp_para = para_grid(i);
        temp_lnprior(i,1) = priodens(temp_para, pmean(para_ind), pstdd(para_ind), pshape(para_ind));
    end
    big_cell{para_ind,1} = para_grid;
    big_cell{para_ind,2} = exp(temp_lnprior);
    
    if yes_mh == 1
        % posterior
        temp_ks = ksdensity(mh_para(:,para_ind), para_grid);
        big_cell2{para_ind,1} = para_grid;
        big_cell2{para_ind,2} = temp_ks;
    end
end


% draw pictures
plot_ind = 1;
nfigures = ceil(npara/9);
for fig_ind = 1:1:nfigures
    %eval(['figure(', num2str(fig_ind),');']);
    figure;
    for subplot_ind = 1:1:9
        subplot(3,3, subplot_ind);
        
        plot(big_cell{plot_ind,1}, big_cell{plot_ind,2}, 'b', 'linewidth', 2);
        hold on
        plot(big_cell2{plot_ind,1}, big_cell2{plot_ind,2}, 'r', 'linewidth', 2);
        hold off
        
        if subplot_ind == 1
            hh = legend('prior', 'posterior');
            set(hh, 'fontsize', 13)
        end
        
        title(pnames{plot_ind});
        if plot_ind == npara
            break
        end
        plot_ind = plot_ind + 1;
    end
end



