function H = trans_fix(C,prior)
% transform matrix C to H
% C: hessian matrix without fixed parameter
% H: hessian matrix with fixed parameter where fixed component of fixed parameter
% zero
% recover prior info
pshape   = prior(:,1);
pmean    = prior(:,2);
pstdd    = prior(:,3);
pmask    = prior(:,4);
pfix     = prior(:,5);
pmaskinv = 1- pmask;
pshape   = pshape.*pmaskinv;

lpmask = logical(pmask);
lpmaskinv = logical(pmaskinv);
nC = size(C,1);
nfix = sum(pmask);
npara = nC+nfix;

H = zeros(npara);
lH = ones(npara);
lH(lpmask,:) = 0;
lH(:,lpmask) = 0;
H(logical(lH)) = C;
