% dsge_pred_sv.m

% for Qone~=0

%  - The program computes trajectories from the DSGE model.
%  - Direct translation of professor Schorfheide's gauss program

% Load file
svorder = [];
for i=1:1:length(estinfo.SVloc)
    svorder = [svorder, num2str(estinfo.SVloc(i))];
end

loadfilename = ['mh_sv',svorder,'kf', num2str(mhrun), '.mat'];
cd(lpath);
load(loadfilename);
% load(['sv', mhrun, '.mat']);
cd(workpath);

% ------------------------------------------------------------------------
% use every nuse-th draw
% ------------------------------------------------------------------------
solsim  = forevery(mh_sol(nburn+1:end,:),nuse_);

% SV parameters
% Csim = forevery(sv_C(nburn+1:end,:),nuse_);
Rsim = forevery(sv_R(nburn+1:end,:),nuse_);
Vsim = forevery(sv_V(nburn+1:end,:),nuse_);
sigtlastsim = forevery(sv_sigtlast(nburn+1:end,:),nuse_);

Csim = zeros(size(Rsim));

% size info
nread = size(solsim,1);

% ------------------------------------------------------------------------
% generate draws from predictive density
% col of predsim: [(var1 1st ~ hst) (var2 1st ~ hst) (var3 1st ~ hst)]
% ------------------------------------------------------------------------
predsim = zeros(nread*npaths_, nv_*hmaxact);
predsimpt = zeros(nread*1, nv_*hmaxact);

for j=1:1:nread

    predsim((j-1)*npaths_+1:j*npaths_,:) ...
        = dsgepredmult_sv_Qone(solsim{j,:}, solsim{j}.Xlastdraw', Rsim(j,:)', Vsim(j,:)', Csim(j,:)', sigtlastsim(j,:), ...
                           hmaxact, npaths_, order_app);
                       
%     predsimpt((j-1)*1+1:j*1,:) ...
%         = dsgepredmult_pt_sv(solsim{j,:}, solsim{j}.Xlastfix', Rsim(j,:)', Vsim(j,:)', sigtlastsim(j,:), ...
%                            hmaxact, 1, order_app);
end

% save predictions
cd(opath);
savefilename = ['predvar_sv',svorder,'kf', num2str(mhrun), '.mat'];
save(savefilename, 'predsim', 'predsimpt');
cd(workpath);

% write out mean forecast

% start log file
whattimeisit = clock;
logfilename  = ['log_pred_sv', num2str(floor(whattimeisit(1,2:6))), '.log'];
cd(opath);
diary(logfilename);
cd(workpath);

% disp results
disp('Predicted ( Average over trajectories) ');
[tiplus reshape(mean(predsim), hmaxact, nv_)]
disp('Actual');
[tiplus YYplus]

diary off
        

























