function [a,b] = gamma_trans_ab(s,nu)
% a: degree of freedom
% b

% GB implementation is based on sig^2 sampling
% INFERENCE: sig^2
% PRIOR    : sig^2 ~ IG(a,b)

% MH implemenation based on DS's prior on sig
% INFERENCE: sig
% PRIOR    : sig ~ IG(s,nu) where s and nu are defined by DS

S2 = s.^2;

a = nu./2;
b = S2.*nu/2;

% -------------------------------------------------------------
% % IG experiment
% nsimul = 1000000;
% 
% % wiki(matlab) notation
% a = 10;
% b = 10;
% 
% xxx2 = (gamrnd(a,b^(-1),[nsimul,1])).^(-1);
% xxx1 = sqrt(xxx2);
% 
% disp('wiki: standard deviation statistics')
% disp('theoretical \ simulation mean');
% mu1  = sqrt(b) *gamma((2*a-1)/2)/gamma(a);
% disp([mu1, mean(xxx1)]);
% disp('theoretical \ simulation variance');
% var1 = b/(a-1) - mu1^2;
% disp([var1, var(xxx1)]);
% 
% disp('wiki: variance statistics')
% disp('theoretical \ simulation mean');
% mu1  = b/(a-1);
% disp([mu1, mean(xxx2)]);
% disp('theoretical \ simulation variance');
% var1 = mu1^2/(a-2);
% disp([var1, var(xxx2)]);
% 
% % schorfheide's notation (and simulation)
% nu = 2*a;%nu
% s2 = b/a;%S2
% 
% xxx1 = sqrt( nu*s2^2./sum( (randn(nu,nsimul)).^2 )' );
% xxx2 = xxx1.^2;
% 
% disp('schorf: standard deviation statistics')
% disp('theoretical \ simulation mean');
% mu2  = sqrt(nu/2*s2)*gamma((nu-1)/2)/gamma(nu/2);
% disp([mu2, mean(xxx1)]);
% disp('theoretical \ simulation variance');
% var2 = nu*s2/2/(nu/2-1) - mu2^2;
% disp([var2, var(xxx1)]);
% 
% disp('schorf: variance statistics')
% disp('theoretical \ simulation mean');
% mu2  = s2*nu/(nu-2);
% disp([mu2, mean(xxx2)]);
% disp('theoretical \ simulation variance');
% var2 = mu2^2*(2/(nu-4));
% disp([var2, var(xxx2)]);
